/*
**  First Person Sniper
** By PikaJade
** Based on Fang Popgun Modifications / Aerial Popgun by Clairebun
** New hand sprites by Dry_Ny
*/

//Add cvars
local corkradius = CV_RegisterVar({name = "fangcorkradius", defaultvalue = 8, flags = CV_NETVAR|CV_CHEAT, PossibleValue = {MIN = 1, MAX = 15}})
local corkspeed = CV_RegisterVar({name = "fangcorkspeed", defaultvalue = 100, flags = CV_NETVAR|CV_CHEAT, PossibleValue = CV_NATURAL})
local clipsize = CV_RegisterVar({name = "fangclipsize", defaultvalue = 2, flags = CV_NETVAR|CV_CHEAT, PossibleValue = CV_NATURAL})
local refiretime = CV_RegisterVar({name = "fangrefiretime", defaultvalue = 15, flags = CV_NETVAR|CV_CHEAT, PossibleValue = CV_NATURAL})
local fireinput = CV_RegisterVar({name = "fangfireinput", defaultvalue = "fire", flags = CV_NETVAR|CV_CHEAT, PossibleValue = {none = 0, fire = 1, firenormal = 2, custom1 = 3, custom2 = 4, custom3 = 5}})
local oldhand = CV_RegisterVar({name = "fangoldhand", defaultvalue = "Off", flags = 0, PossibleValue = {Off = 0, On = 1}})

//Define air shooting sprites
freeslot("SPR2_FAIR","S_PLAY_AIRFIRE1","S_PLAY_AIRFIRE2","sfx_rldend","sfx_nmehit","sfx_msfire","sfx_reload","sfx_qkdraw")
states[S_PLAY_AIRFIRE1] = {
        sprite = SPR_PLAY,
        frame = SPR2_FAIR,
        tics = -1,
}
states[S_PLAY_AIRFIRE2] = {
        sprite = SPR_PLAY,
        frame = SPR2_FAIR,
        tics = -1,
}
local airstate1 = S_PLAY_AIRFIRE1
local airstate2 = S_PLAY_AIRFIRE2
local reloadsound = sfx_reload
local reloadfinishsound = sfx_rldend
local misfiresound =  sfx_msfire
local hitenemysound = sfx_nmehit
local gunslinging = false
local handoffy = {0,0}
local handoffx = {0,0}

local IsFang = function(player)
	return player.mo and player.mo.skin == "fang"
end

local function zpos(posmo, item)
	return (posmo.z + (posmo.height - mobjinfo[item].height)/2)
end

local function newGunslinger(player)
	
	local mo = player.mo
	local onground = P_IsObjectOnGround(mo)
	local canstand = true
	
	player.gunslinging = true
	
	local thrust = R_PointToDist2(0,0,mo.momx,mo.momy)
	
	if player.displaybob == nil
	or player.panim == PA_ABILITY2
	or not onground
	or thrust <= 2*FRACUNIT
	or (player.reloadticks and player.reloadticks >= 5)
		player.displaybob = 0
	else
		player.displaybob = $ + (75*thrust)
	end
	
	if player.ammo == nil
		player.ammo = 2
	end
	
	//State: ready to gunsling
	if not ((player.pflags & (PF_SLIDING)) or (player.exiting) or (P_PlayerInPain(player)))
	and not (player.weapondelay)
	and not (player.panim == PA_ABILITY2)
		//Trigger firing action
		if (player.cmd.buttons & BT_USE)
			local bullet = nil

			mo.state = S_PLAY_FIRE
			player.panim = PA_ABILITY2
			player.weapondelay = refiretime.value
			if player.ammo <= 0
				S_StartSound(player.mo,misfiresound)
			else 
				player.ammo = $-1
				bullet = P_SpawnPointMissile(
					mo,
					mo.x + P_ReturnThrustX(nil, mo.angle, FRACUNIT),
					mo.y + P_ReturnThrustY(nil, mo.angle, FRACUNIT),
					player.viewz + (sin(player.aiming)*90),
					player.revitem,
					mo.x, mo.y, player.viewz
				)
			end
			if bullet
			and bullet.valid
				P_InstaThrust(bullet,bullet.angle,corkspeed.value*cos(player.aiming))
				bullet.momz = corkspeed.value*sin(player.aiming)
				bullet.radius = corkradius.value
			end
			player.drawangle = mo.angle
			//Air function
			if not(P_IsObjectOnGround(mo))
				P_SetMobjStateNF(mo,airstate1)
				player.mo.sprite2 = SPR2_FAIR
				player.airgun = true
			end
		end
	end
	
	//Running and jumping
	if player.panim == PA_ABILITY2 and P_IsObjectOnGround(mo) and player.cmd.buttons&BT_JUMP and not(player.popgunhistory&BT_JUMP)
		mo.state = S_PLAY_WALK
	end
	
	//Air gunning
	if not(P_IsObjectOnGround(mo)) and player.airgun == true and player.weapondelay
		if player.weapondelay < refiretime.value-1 and player.weapondelay > refiretime.value-3
			P_SetMobjStateNF(mo,airstate2)
		elseif player.weapondelay < refiretime.value-4
			P_SetMobjStateNF(mo,airstate1)
		end
		player.pflags = $|PF_JUMPDOWN
	end	
	if P_IsObjectOnGround(mo) and player.airgun == true
	or not player.weapondelay
		player.airgun = false
		if (player.weapondelay) then
			mo.state = S_PLAY_FIRE_FINISH
		end
	end
	
	if player.panim != PA_ABILITY2
		player.laststate = player.panim
		if player.ammo < clipsize.value
		and not(player.weapondelay)
		and player.panim != PA_PAIN
		and player.panim != PA_ABILITY2
			player.reloadticks = $+1
			if player.reloadticks == 5
				S_StartSound(player.mo,reloadsound)
			elseif player.reloadticks > 5
				player.reloadbob = min($+3,27)
				if player.reloadticks >= 30
					S_StartSound(player.mo,reloadfinishsound)
					player.ammo = clipsize.value
					player.reloadticks = 0
				end
			end
		else
			if player.panim != PA_PAIN
			and player.panim != PA_ABILITY
				player.reloadbob = max($-3,0)
			else
				player.reloadbob = 0
			end
			player.reloadticks = 0
			S_StopSoundByID(player.mo,reloadsound)
		end
	else
		player.reloadticks = 0
		player.reloadbob = 0
		S_StopSoundByID(player.mo,reloadsound)
		if player.weapondelay <= 0
			player.state = S_PLAY_WALK
			player.panim = player.laststate
		end
	end
end


////
//Hooks

//Input control before movement is handled
addHook("PreThinkFrame",do
	for player in players.iterate
		if not(IsFang(player))
			return end
		
		local firebutton = false
		
		if (player.cmd.buttons & BT_ATTACK
		and fireinput.value == 1
		and not G_RingSlingerGametype())
		or (player.cmd.buttons & BT_FIRENORMAL
		and fireinput.value == 2
		and not G_RingSlingerGametype())
		or (player.cmd.buttons & BT_CUSTOM1
		and fireinput.value == 3)
		or (player.cmd.buttons & BT_CUSTOM2
		and fireinput.value == 4)
		or (player.cmd.buttons & BT_CUSTOM3
		and fireinput.value == 5)
			firebutton = true
		end
		
		if firebutton
			player.cmd.buttons = $|BT_SPIN
		end
	end
end)

//Main body for popgun firing control	
addHook("PlayerThink",function(player)
	if not(IsFang(player)) return end
	
	if player.justspawned == nil
	or player.playerstate != PST_LIVE
	or leveltime == 0
		player.justspawned = false
	end
		
	if player.ammoflash
		player.ammoflash = ($+1)%10
	else
		player.ammoflash = 1
	end
	
	//Disallow native CA2_GUNSLINGER functionality
	if player.charability2 == CA2_GUNSLINGER
		player.charability2 = CA2_NONE 
	end
	
	player.gunslinging = false
	
	//Define reload bob
	if not player.reloadbob
		player.reloadbob = 0
	end

	//Unable to use gun during certain states
	if player.powers[pw_nocontrol]
	or player.powers[pw_carry]
	or player.pflags&PF_SPINNING
	or (player.playerstate != PST_LIVE and player.jointime != 0)
	or player.exiting 
	or P_PlayerInPain(player)
		player.airgun = false
		player.reloadticks = 0
	return end

	if player.popgunhistory == nil
		player.popgunhistory = player.cmd.buttons
	end
	
	//Do Gunslinger
	newGunslinger(player)
	
	//Make SPR2 behave
	if (player.mo.state == S_PLAY_AIRFIRE1) then
		player.mo.frame = 0
	end
	
	if (player.mo.state == S_PLAY_AIRFIRE2) then
		player.mo.frame = 1
	end
	
	if player.justspawned
		return end
		
	player.ammo = 2
	player.reloadticks = 0

	local fp = false
	if player.playerstate == PST_REBORN
	or player.mo.flags2 & MF2_TWOD
		fp = true
	end
	
	//Force first person
	if secondarydisplayplayer == player
	and splitscreen
		camera2.chase = fp
	else
		camera.chase = fp
	end
	
	player.justspawned = 1
end)

//Update button history
addHook("PostThinkFrame",do
	for player in players.iterate
		player.popgunhistory = player.cmd.buttons	
	end
end)

//Shield ability regulation
addHook("ShieldSpecial",function(player)
	if IsFang(player)
		return true
	end
end)

//HUD
hud.add(function(v, p, cam)
	if not(IsFang(p))
		return end
	
	if p.ammo == 0
	and p.ammoflash >= 5
		v.draw(16,58,v.cachePatch"STTRAMMO",V_HUDTRANS|V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
	else
		v.draw(16,58,v.cachePatch"STTAMMO",V_HUDTRANS|V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
	end
	v.drawNum(120,58,p.ammo,V_HUDTRANS|V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
	
	if cam.chase
	or p.awayviewtics
	or not p.gunslinging
		return end
	
	if oldhand.value
		if p.weapondelay  > refiretime.value/2
			v.draw(160,110,v.cachePatch("HUDGUNFIRE"),V_PERPLAYER|V_SNAPTOBOTTOM,v.getColormap(p.mo.skin,p.mo.color))
		else
			v.draw(160,128+p.reloadbob,v.cachePatch("HUDGUNIDLE"),V_PERPLAYER|V_SNAPTOBOTTOM,v.getColormap(p.mo.skin,p.mo.color))
		end
	else
		local mycam = 1
		if secondarydisplayplayer == p
		and splitscreen
			mycam = 2
		end
	
		local offx = (cos(p.displaybob+ANGLE_90) * 16)
		local offy = (sin(p.displaybob*2) * 16)
		if p.pflags & PF_BOUNCING
			offy = 25*FRACUNIT
		end
		
		if not P_IsObjectOnGround(p.mo)
			offy = $ + p.mo.momz
		end
		offy = max($,-16*FRACUNIT)
		
		if p.weapondelay  > refiretime.value/2
			offx = 0
			offy = 0
		end
		
		handoffy[mycam] = ease.outsine(FRACUNIT/3,$,offy)
		handoffx[mycam] = ease.outsine(FRACUNIT/3,$,offx)
		
		if p.weapondelay  > refiretime.value/2
			v.drawScaled(135*FRACUNIT+handoffx[mycam],132*FRACUNIT+handoffy[mycam],3*FRACUNIT,v.cachePatch("HUDNEWFIRE"),V_PERPLAYER|V_SNAPTOBOTTOM,v.getColormap(p.mo.skin,p.mo.color))
		elseif p.ammo
		and p.ammo > 0
			v.drawScaled(((135*FRACUNIT)-(FRACUNIT/2))+handoffx[mycam],(123+p.reloadbob)*FRACUNIT+handoffy[mycam],3*FRACUNIT,v.cachePatch("HUDNEWIDLE"),V_PERPLAYER|V_SNAPTOBOTTOM,v.getColormap(p.mo.skin,p.mo.color))
		else
			v.drawScaled((135*FRACUNIT)-(FRACUNIT/2)+handoffx[mycam],(123+p.reloadbob)*FRACUNIT+handoffy[mycam],3*FRACUNIT,v.cachePatch("HUDNEWEMPTY"),V_PERPLAYER|V_SNAPTOBOTTOM,v.getColormap(p.mo.skin,p.mo.color))
		end
	end
	
end, game)

//Give reward when hitting an enemy
addHook("MobjDamage",function(t,i,mo,d,dt)
	if mo
	and i
	and t
	and mo.player
	and mo.skin == "fang"
	and i.type == MT_CORK
		mo.player.reloadticks = 0
		mo.player.ammo = clipsize.value
		S_StartSound(mo,hitenemysound)
		S_StartSound(mo,reloadfinishsound)
		if t.health - d <= 0
		and t.flags & MF_ENEMY
		and ~t.flags & MF_BOSS
			mo.player.rings = $+1
			S_StartSound(mo,sfx_itemup)
		end
	end
	return
end)